## qpid-cpp 0.14

=== src/CMakeLists.txt ===
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#

# library versions
include (versions.cmake)

# Option to require building optional plugins
foreach (r ${REQUIRE})
  set(${r}_force ON)
  message(STATUS "Forcing ${r} to ${${r}_force}")
endforeach(r)

include(CheckFunctionExists)
include(CheckIncludeFileCXX)
include(CheckIncludeFiles)
include(CheckIncludeFileCXX)
include(CheckLibraryExists)
include(CheckSymbolExists)
include(FindBoost)
include(FindDoxygen)

#set (CMAKE_VERBOSE_MAKEFILE ON)  # for debugging

#
# Set up installation of .pdb files if the compiler is Visual Studio
#
# Sample: install_pdb (qpidcommon ${QPID_COMPONENT_COMMON})
#
MACRO (install_pdb theLibrary theComponent)
    if (MSVC)
        get_target_property(library_dll ${theLibrary} LOCATION)
        string(REPLACE .dll .pdb library_pdb ${library_dll})
        string(REPLACE $(OutDir) \${CMAKE_INSTALL_CONFIG_NAME} library_pdb ${library_pdb})
        string(REPLACE .pdb d.pdb libraryd_pdb ${library_pdb})
        #message(STATUS "_pdb: ${library_pdb}, ${libraryd_pdb}")
        install (PROGRAMS
                ${library_pdb}
                DESTINATION ${QPID_INSTALL_LIBDIR}/ReleasePDB
                COMPONENT ${theComponent}
                OPTIONAL
                CONFIGURATIONS Release|MinSizeRel)
        install (PROGRAMS
                ${library_pdb}
                DESTINATION ${QPID_INSTALL_LIBDIR}/ReleasePDB
                COMPONENT ${theComponent}
                CONFIGURATIONS RelWithDebInfo)
        install (PROGRAMS
                ${libraryd_pdb}
                DESTINATION ${QPID_INSTALL_LIBDIR}/DebugPDB
                COMPONENT ${theComponent}
                CONFIGURATIONS Debug)
    endif (MSVC)
ENDMACRO (install_pdb)

#
# inherit_value - if the symbol is undefined then set it to the given value.
# Set flag to indicate this symbol was defined here.
#
MACRO (inherit_value theSymbol theValue)
    if (NOT DEFINED ${theSymbol})
        set (${theSymbol} ${theValue})
        # message ("Set symbol '${theSymbol}' to value '${theValue}'")
        set (${theSymbol}_inherited = "true")
    endif (NOT DEFINED ${theSymbol})
ENDMACRO (inherit_value)

#
# If compiler is Visual Studio then create a "version resource" for the project.
# Use this call to override CPACK and file global settings but not file per-project settings.
# Two groups of four version numbers specify "file" and "product" versions separately.
#
# Sample: add_msvc_version_full (qmfengine library dll 1 0 0 1 1 0 0 1)
#
MACRO (add_msvc_version_full verProject verProjectType verProjectFileExt verFN1 verFN2 verFN3 verFN4 verPN1 verPN2 verPN3 verPN4)
    if (MSVC)
        # Create project-specific version strings
        inherit_value ("winver_${verProject}_FileVersionBinary"    "${verFN1},${verFN2},${verFN3},${verFN4}")
        inherit_value ("winver_${verProject}_ProductVersionBinary" "${verPN1},${verPN2},${verPN3},${verPN4}")
        inherit_value ("winver_${verProject}_FileVersionString"    "${verFN1}, ${verFN2}, ${verFN3}, ${verFN4}")
        inherit_value ("winver_${verProject}_ProductVersionString" "${verPN1}, ${verPN2}, ${verPN3}, ${verPN4}")
        inherit_value ("winver_${verProject}_FileDescription"      "${winver_PACKAGE_NAME}-${verProject} ${verProjectType}")
        inherit_value ("winver_${verProject}_LegalCopyright"       "${winver_LEGAL_COPYRIGHT}")
        inherit_value ("winver_${verProject}_InternalName"         "${verProject}")
        inherit_value ("winver_${verProject}_OriginalFilename"     "${verProject}.${verProjectFileExt}")
        inherit_value ("winver_${verProject}_ProductName"          "${winver_DESCRIPTION_SUMMARY}")

        # Create strings to be substituted into the template file
        set ("winverFileVersionBinary"     "${winver_${verProject}_FileVersionBinary}")
        set ("winverProductVersionBinary"  "${winver_${verProject}_ProductVersionBinary}")
        set ("winverFileVersionString"     "${winver_${verProject}_FileVersionString}")
        set ("winverProductVersionString"  "${winver_${verProject}_ProductVersionString}")
        set ("winverFileDescription"       "${winver_${verProject}_FileDescription}")
        set ("winverLegalCopyright"        "${winver_${verProject}_LegalCopyright}")
        set ("winverInternalName"          "${winver_${verProject}_InternalName}")
        set ("winverOriginalFilename"      "${winver_${verProject}_OriginalFilename}")
        set ("winverProductName"           "${winver_${verProject}_ProductName}")

        configure_file(${CMAKE_CURRENT_SOURCE_DIR}/windows/resources/template-resource.rc
                       ${CMAKE_CURRENT_BINARY_DIR}/windows/resources/${verProject}-resource.rc)
        set (${verProject}_SOURCES
            ${${verProject}_SOURCES}
            ${CMAKE_CURRENT_BINARY_DIR}/windows/resources/${verProject}-resource.rc
        )
    endif (MSVC)
ENDMACRO (add_msvc_version_full)

#
# If compiler is Visual Studio then create a "version resource" for the project.
# Use this call to accept file override version settings or
#  inherited CPACK_PACKAGE_VERSION version settings.
#
# Sample: add_msvc_version (qpidcommon library dll)
#
MACRO (add_msvc_version verProject verProjectType verProjectFileExt)
    if (MSVC)
        add_msvc_version_full (${verProject}
                               ${verProjectType}
                               ${verProjectFileExt}
                               ${winver_FILE_VERSION_N1}
                               ${winver_FILE_VERSION_N2}
                               ${winver_FILE_VERSION_N3}
                               ${winver_FILE_VERSION_N4}
                               ${winver_PRODUCT_VERSION_N1}
                               ${winver_PRODUCT_VERSION_N2}
                               ${winver_PRODUCT_VERSION_N3}
                               ${winver_PRODUCT_VERSION_N4})
    endif (MSVC)
ENDMACRO (add_msvc_version)


#
# Install optional windows version settings. Override variables are specified in a file.
#
include (./CMakeWinVersions.cmake OPTIONAL)

#
# Inherit global windows version settings from CPACK settings.
#
inherit_value ("winver_PACKAGE_NAME"         "${CPACK_PACKAGE_NAME}")
inherit_value ("winver_DESCRIPTION_SUMMARY"  "${CPACK_PACKAGE_DESCRIPTION_SUMMARY}")
inherit_value ("winver_FILE_VERSION_N1"      "${CPACK_PACKAGE_VERSION_MAJOR}")
inherit_value ("winver_FILE_VERSION_N2"      "${CPACK_PACKAGE_VERSION_MINOR}")
inherit_value ("winver_FILE_VERSION_N3"      "${CPACK_PACKAGE_VERSION_PATCH}")
inherit_value ("winver_FILE_VERSION_N4"      "1")
inherit_value ("winver_PRODUCT_VERSION_N1"   "${winver_FILE_VERSION_N1}")
inherit_value ("winver_PRODUCT_VERSION_N2"   "${winver_FILE_VERSION_N2}")
inherit_value ("winver_PRODUCT_VERSION_N3"   "${winver_FILE_VERSION_N3}")
inherit_value ("winver_PRODUCT_VERSION_N4"   "${winver_FILE_VERSION_N4}")
inherit_value ("winver_LEGAL_COPYRIGHT"      "")


# check if we generate source as part of the build
#   - rubygen generates the amqp spec and clustering
#   - managementgen generates the broker management code
#
# rubygen subdir is excluded from stable distributions
# If the main AMQP spec is present, then check if ruby and python are
# present, and if any sources have changed, forcing a re-gen of source code.

set(AMQP_SPEC_DIR ${qpid-cpp_SOURCE_DIR}/../specs)
set(AMQP_SPEC ${AMQP_SPEC_DIR}/amqp.0-10-qpid-errata.xml)
if (EXISTS ${AMQP_SPEC})
  include(FindRuby)
  include(FindPythonInterp)
  if (NOT RUBY_EXECUTABLE)
    message(FATAL_ERROR "Can't locate ruby, needed to generate source files.")
  endif (NOT RUBY_EXECUTABLE)
  if (NOT PYTHON_EXECUTABLE)
    message(FATAL_ERROR "Can't locate python, needed to generate source files.")
  endif (NOT PYTHON_EXECUTABLE)

  set(specs ${AMQP_SPEC} ${qpid-cpp_SOURCE_DIR}/xml/cluster.xml)
  set(regen_amqp OFF)
  set(rgen_dir ${qpid-cpp_SOURCE_DIR}/rubygen)
  file(GLOB_RECURSE rgen_progs ${rgen_dir}/*.rb)
  # If any of the specs, or any of the sources used to generate code, change
  # then regenerate the sources.
  foreach (spec_file ${specs} ${rgen_progs})
    if (${spec_file} IS_NEWER_THAN ${CMAKE_CURRENT_BINARY_DIR}/rubygen.cmake)
      set(regen_amqp ON)
    endif (${spec_file} IS_NEWER_THAN ${CMAKE_CURRENT_BINARY_DIR}/rubygen.cmake)
  endforeach (spec_file ${specs})
  if (regen_amqp)
    message(STATUS "Regenerating AMQP protocol sources")
execute_process(COMMAND ${RUBY_EXECUTABLE} -I ${rgen_dir} ${rgen_dir}/generate ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_BINARY_DIR}/../include  ${specs} all rubygen.cmake
                    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
  else (regen_amqp)
    message(STATUS "No need to generate AMQP protocol sources")
  endif (regen_amqp)

  set(mgmt_specs ${AMQP_SPEC_DIR}/management-schema.xml
                 ${CMAKE_CURRENT_SOURCE_DIR}/qpid/acl/management-schema.xml
                 ${CMAKE_CURRENT_SOURCE_DIR}/qpid/cluster/management-schema.xml)
  set(mgen_dir ${qpid-cpp_SOURCE_DIR}/managementgen)
  set(regen_mgmt OFF)
  foreach (spec_file ${mgmt_specs})
    if (${spec_file} IS_NEWER_THAN ${CMAKE_CURRENT_BINARY_DIR}/managementgen.cmake)
      message(STATUS "${spec_file} is newer")
      set(regen_mgmt ON)
    endif (${spec_file} IS_NEWER_THAN ${CMAKE_CURRENT_BINARY_DIR}/managementgen.cmake)
  endforeach (spec_file ${mgmt_specs})
  if (regen_mgmt)
    message(STATUS "Regenerating Qpid Management Framework sources")
execute_process(COMMAND ${PYTHON_EXECUTABLE} ${mgen_dir}/qmf-gen -c managementgen.cmake -b -q -o ${CMAKE_CURRENT_BINARY_DIR}/qmf ${mgmt_specs}
                    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
  else (regen_mgmt)
    message(STATUS "No need to generate Qpid Management Framework sources")
  endif (regen_mgmt)

  # Pull in the names of the generated files, i.e. ${rgen_framing_srcs}
  include (${CMAKE_CURRENT_BINARY_DIR}/rubygen.cmake)
  include (${CMAKE_CURRENT_BINARY_DIR}/managementgen.cmake)

else (EXISTS ${AMQP_SPEC})
  message(STATUS "No AMQP spec... presume generated sources are included")
  set(QPID_GENERATED_HEADERS_IN_SOURCE ON)
  include (rubygen.cmake)
  include (managementgen.cmake)
endif (EXISTS ${AMQP_SPEC})

find_program(HELP2MAN help2man DOC "Location of the help2man program")
option(GEN_MANPAGES "Use help2man to generate man pages" ON)
if (GEN_MANPAGES AND NOT HELP2MAN)
  message(STATUS "Can't locate the help2man command; man pages will not be generated")
  set (GEN_MANPAGES OFF)
endif (GEN_MANPAGES AND NOT HELP2MAN)

# FindDoxygen module tries to locate doxygen and Graphviz dot
set (docs_default ON)
if (NOT DOXYGEN_EXECUTABLE)
  set (docs_default OFF)
endif (NOT DOXYGEN_EXECUTABLE)
option(GEN_DOXYGEN "Use doxygen to generate user documentation" ${docs_default})
if (GEN_DOXYGEN AND NOT DOXYGEN_EXECUTABLE)
  message(STATUS "Can't locate the doxygen command; user documentation will not be generated")
  set (GEN_DOXYGEN OFF)
endif (GEN_DOXYGEN AND NOT DOXYGEN_EXECUTABLE)

find_program(VALGRIND valgrind DOC "Location of the valgrind program")
option(ENABLE_VALGRIND "Use valgrind to detect run-time problems" ON)
if (ENABLE_VALGRIND AND NOT VALGRIND)
  message(STATUS "Can't locate the valgrind command; no run-time error detection")
endif (ENABLE_VALGRIND AND NOT VALGRIND)

if (CMAKE_COMPILER_IS_GNUCXX)

=== examples/qmf-console/CMakeLists.txt ===
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#

add_example(qmf-console console qmfconsole)
add_example(qmf-console printevents qmfconsole)
add_example(qmf-console ping qmfconsole)
add_example(qmf-console queuestats qmfconsole)

=== src/tests/CMakeLists.txt ===
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#

# Enable dashboard reporting.
include (CTest)

# Make sure that everything get built before the tests
# Need to create a var with all the necessary top level targets

add_definitions(-DBOOST_TEST_DYN_LINK)
include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )

include (FindPythonInterp)

# Create the environment scripts for tests
set (abs_srcdir ${CMAKE_CURRENT_SOURCE_DIR})
set (abs_builddir ${CMAKE_CURRENT_BINARY_DIR})
set (abs_top_srcdir ${CMAKE_SOURCE_DIR})
set (abs_top_builddir ${CMAKE_BINARY_DIR})
set (builddir_lib_suffix "")
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/test_env.sh.in
  ${CMAKE_CURRENT_BINARY_DIR}/test_env.sh)


# If valgrind is selected in the configuration step, set up the path to it
# for CTest.
if (ENABLE_VALGRIND)
  set (MEMORYCHECK_COMMAND ${VALGRIND})
  set (MEMORYCHECK_COMMAND_OPTIONS "--gen-suppressions=all
--leak-check=full
--demangle=yes
--suppressions=${CMAKE_CURRENT_SOURCE_DIR}/.valgrind.supp
--num-callers=25
--log-file=ctest_valgrind.vglog")
endif (ENABLE_VALGRIND)

# Using the Boost DLLs triggers warning 4275 on Visual Studio
# (non dll-interface class used as base for dll-interface class).
# This is ok, so suppress the warning.
# Also, boost lengthy names trigger warning 4503, decorated name length exceeded
# and using getenv() triggers insecure CRT warnings which we can silence in the
# test environment.
if (MSVC)
  add_definitions( /wd4275 /wd4503 /D_CRT_SECURE_NO_WARNINGS)
endif (MSVC)

# Like this to work with cmake 2.4 on Unix
set (qpid_test_boost_libs 
     ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY} ${Boost_SYSTEM_LIBRARY})

# Macro to make it easier to remember where the tests are built
macro(remember_location testname)
  set (${testname}_LOCATION ${CMAKE_CURRENT_BINARY_DIR}/${testname}${CMAKE_EXECUTABLE_SUFFIX})
endmacro(remember_location)

# Windows uses some process-startup calls to ensure that errors, etc. don't
# result in error boxes being thrown up. Since it's expected that most test
# runs will be in scripts, the default is to force these outputs to stderr
# instead of windows. If you want to remove this code, build without the
# QPID_WINDOWS_DEFAULT_TEST_OUTPUTS ON.
if (CMAKE_SYSTEM_NAME STREQUAL Windows)
  option(QPID_WINDOWS_DEFAULT_TEST_OUTPUTS "Use default error-handling on Windows tests" OFF)
  if (NOT QPID_WINDOWS_DEFAULT_TEST_OUTPUTS)
    set(platform_test_additions windows/DisableWin32ErrorWindows.cpp)
  endif (NOT QPID_WINDOWS_DEFAULT_TEST_OUTPUTS)
endif (CMAKE_SYSTEM_NAME STREQUAL Windows)

#
# Unit test program
#
# Unit tests are built as a single program to reduce valgrind overhead
# when running the tests. If you want to build a subset of the tests run
# ccmake and set unit_tests_to_build to the set you want to build.

set(unit_tests_to_build
    exception_test
    RefCounted
    SessionState
    logging
    AsyncCompletion
    Url
    Uuid
    Shlib
    FieldValue
    FieldTable
    Array
    QueueOptionsTest
    InlineAllocator
    InlineVector
    ClientSessionTest
    MessagingSessionTests
    SequenceSet
    StringUtils
    RangeSet
    AtomicValue
    QueueTest
    AccumulatedAckTest
    DtxWorkRecordTest
    DeliveryRecordTest
    ExchangeTest
    HeadersExchangeTest
    MessageTest
    QueueRegistryTest
    QueuePolicyTest
    QueueFlowLimitTest
    FramingTest
    HeaderTest
    SequenceNumberTest
    TimerTest
    TopicExchangeTest
    TxBufferTest
    TxPublishTest
    MessageBuilderTest
    ManagementTest
    MessageReplayTracker
    ConsoleTest
    QueueEvents
    ProxyTest
    RetryList
    RateFlowcontrolTest
    FrameDecoder
    ReplicationTest
    ClientMessageTest
    PollableCondition
    Variant
    ClientMessage
    ${xml_tests}
    CACHE STRING "Which unit tests to build"
   )

mark_as_advanced(unit_tests_to_build)

# Disabled till we move to amqp_0_10 codec.
# 	amqp_0_10/serialize.cpp allSegmentTypes.h \
# 	amqp_0_10/ProxyTemplate.cpp \
# 	amqp_0_10/apply.cpp \
# 	amqp_0_10/Map.cpp \
# 	amqp_0_10/handlers.cpp 

add_executable (unit_test unit_test
                ${unit_tests_to_build} ${platform_test_additions})
target_link_libraries (unit_test
                       ${qpid_test_boost_libs}
                       qpidmessaging qpidbroker qmfconsole)
remember_location(unit_test)

add_library (shlibtest MODULE shlibtest.cpp)

if (BUILD_CLUSTER)
  include (cluster.cmake)
endif (BUILD_CLUSTER)

# FIXME aconway 2009-11-30: enable SSL
#if SSL
#include ssl.mk
#endif

#
# Other test programs
#
add_executable (qpid-perftest qpid-perftest.cpp ${platform_test_additions})
target_link_libraries (qpid-perftest qpidclient)
#qpid_perftest_SOURCES=qpid-perftest.cpp test_tools.h TestOptions.h ConnectionOptions.h
remember_location(qpid-perftest)

add_executable (qpid-txtest qpid-txtest.cpp ${platform_test_additions})
target_link_libraries (qpid-txtest qpidclient)
#qpid_txtest_SOURCES=qpid-txtest.cpp  TestOptions.h ConnectionOptions.h
remember_location(qpid-txtest)

add_executable (qpid-latency-test qpid-latency-test.cpp ${platform_test_additions})
target_link_libraries (qpid-latency-test qpidclient)
#qpid_latencytest_SOURCES=qpid-latency-test.cpp TestOptions.h ConnectionOptions.h
remember_location(qpid-latency-test)

add_executable (echotest echotest.cpp ${platform_test_additions})
target_link_libraries (echotest qpidclient)
#echotest_SOURCES=echotest.cpp TestOptions.h ConnectionOptions.h
remember_location(echotest)

add_executable (qpid-client-test qpid-client-test.cpp ${platform_test_additions})
target_link_libraries (qpid-client-test qpidclient)
#qpid_client_test_SOURCES=qpid-client-test.cpp TestOptions.h ConnectionOptions.h
remember_location(qpid-client-test)

add_executable (qpid-topic-listener qpid-topic-listener.cpp ${platform_test_additions})
target_link_libraries (qpid-topic-listener qpidclient)
#qpid_topic_listener_SOURCES=qpid-topic-listener.cpp TestOptions.h ConnectionOptions.h
remember_location(qpid-topic-listener)

add_executable (qpid-topic-publisher qpid-topic-publisher.cpp ${platform_test_additions})
target_link_libraries (qpid-topic-publisher qpidclient)
#qpid_topic_publisher_SOURCES=qpid-topic-publisher.cpp TestOptions.h ConnectionOptions.h
remember_location(qpid-topic-publisher)

add_executable (publish publish.cpp ${platform_test_additions})
target_link_libraries (publish qpidclient)
#publish_SOURCES=publish.cpp TestOptions.h ConnectionOptions.h
remember_location(publish)

add_executable (consume consume.cpp ${platform_test_additions})
target_link_libraries (consume qpidclient)
#consume_SOURCES=consume.cpp  TestOptions.h ConnectionOptions.h
remember_location(consume)

add_executable (header_test header_test.cpp ${platform_test_additions})
target_link_libraries (header_test qpidclient)
#header_test_SOURCES=header_test.cpp TestOptions.h ConnectionOptions.h
remember_location(header_test)

add_executable (declare_queues declare_queues.cpp ${platform_test_additions})
target_link_libraries (declare_queues qpidclient)
remember_location(declare_queues)

add_executable (replaying_sender replaying_sender.cpp ${platform_test_additions})
target_link_libraries (replaying_sender qpidclient)
remember_location(replaying_sender)

add_executable (resuming_receiver resuming_receiver.cpp ${platform_test_additions})
target_link_libraries (resuming_receiver qpidclient)
remember_location(resuming_receiver)

add_executable (txshift txshift.cpp ${platform_test_additions})
target_link_libraries (txshift qpidclient)
#txshift_SOURCES=txshift.cpp  TestOptions.h ConnectionOptions.h
remember_location(txshift)

add_executable (txjob txjob.cpp ${platform_test_additions})
target_link_libraries (txjob qpidclient)
#txjob_SOURCES=txjob.cpp  TestOptions.h ConnectionOptions.h
remember_location(txjob)

add_executable (receiver receiver.cpp ${platform_test_additions})
target_link_libraries (receiver qpidclient)
#receiver_SOURCES=receiver.cpp  TestOptions.h ConnectionOptions.h
remember_location(receiver)

add_executable (sender sender.cpp Statistics.cpp ${platform_test_additions})
target_link_libraries (sender qpidmessaging)
#sender_SOURCES=sender.cpp  TestOptions.h ConnectionOptions.h
remember_location(sender)

add_executable (qpid-receive qpid-receive.cpp Statistics.cpp ${platform_test_additions})
target_link_libraries (qpid-receive qpidmessaging)
remember_location(qpid-receive)

add_executable (qpid-send qpid-send.cpp Statistics.cpp ${platform_test_additions})
target_link_libraries (qpid-send qpidmessaging)
remember_location(qpid-send)

add_executable (qpid-ping qpid-ping.cpp ${platform_test_additions})
target_link_libraries (qpid-ping qpidclient)
remember_location(qpid-ping)

add_executable (datagen datagen.cpp ${platform_test_additions})
target_link_libraries (datagen qpidclient)
remember_location(datagen)

add_executable (msg_group_test msg_group_test.cpp ${platform_test_additions})
target_link_libraries (msg_group_test qpidmessaging)
remember_location(msg_group_test)


# qpid-perftest and qpid-latency-test are generally useful so install them
install (TARGETS qpid-perftest qpid-latency-test RUNTIME
         DESTINATION ${QPID_INSTALL_BINDIR})

if (CMAKE_SYSTEM_NAME STREQUAL Windows)
  set (ENV{OUTDIR} ${EXECUTABLE_OUTPUT_PATH})
  set (test_script_suffix ".ps1")
  set (shell "powershell")
endif (CMAKE_SYSTEM_NAME STREQUAL Windows)

set(test_wrap ${shell} ${CMAKE_CURRENT_SOURCE_DIR}/run_test${test_script_suffix})

add_test (unit_test ${test_wrap} ${unit_test_LOCATION})
add_test (start_broker ${shell} ${CMAKE_CURRENT_SOURCE_DIR}/start_broker${test_script_suffix})
add_test (qpid-client-test ${test_wrap} ${qpid-client-test_LOCATION})
add_test (quick_perftest ${test_wrap} ${qpid-perftest_LOCATION} --summary --count 100)
add_test (quick_topictest ${test_wrap} ${CMAKE_CURRENT_SOURCE_DIR}/quick_topictest${test_script_suffix})
add_test (quick_txtest ${test_wrap} ${qpid-txtest_LOCATION} --queues 4 --tx-count 10 --quiet)
if (PYTHON_EXECUTABLE)
  add_test (run_header_test ${shell} ${CMAKE_CURRENT_SOURCE_DIR}/run_header_test${test_script_suffix})
  add_test (python_tests ${test_wrap} ${CMAKE_CURRENT_SOURCE_DIR}/python_tests${test_script_suffix})
endif (PYTHON_EXECUTABLE)
add_test (stop_broker ${shell} ${CMAKE_CURRENT_SOURCE_DIR}/stop_broker${test_script_suffix})
if (PYTHON_EXECUTABLE)
  add_test (ipv6_test ${shell} ${CMAKE_CURRENT_SOURCE_DIR}/ipv6_test${test_script_suffix})
  add_test (federation_tests ${shell} ${CMAKE_CURRENT_SOURCE_DIR}/run_federation_tests${test_script_suffix})
if (BUILD_ACL)
  add_test (acl_tests ${shell} ${CMAKE_CURRENT_SOURCE_DIR}/run_acl_tests${test_script_suffix})
endif (BUILD_ACL)
add_test (dynamic_log_level_test ${shell} ${CMAKE_CURRENT_SOURCE_DIR}/dynamic_log_level_test${test_script_suffix})
if (BUILD_MSSQL)
  add_test (store_tests ${shell} ${CMAKE_CURRENT_SOURCE_DIR}/run_store_tests${test_script_suffix} MSSQL)
endif (BUILD_MSSQL)
if (BUILD_MSCLFS)
  add_test (store_tests ${shell} ${CMAKE_CURRENT_SOURCE_DIR}/run_store_tests${test_script_suffix} MSSQL-CLFS)
endif (BUILD_MSCLFS)
endif (PYTHON_EXECUTABLE)

add_library(test_store MODULE test_store.cpp)
target_link_libraries (test_store qpidbroker qpidcommon)
set_target_properties (test_store PROPERTIES PREFIX "")

#EXTRA_DIST +=								\
#  run_test vg_check							\

=== debian/changelog ===
qpid-cpp (0.14-2) unstable; urgency=low

  * Create missing spool directory.

 -- Cajus Pollmeier <cajus@debian.org>  Wed, 01 Feb 2012 07:51:20 +0100

qpid-cpp (0.14-1) unstable; urgency=low

  * New upstream release.

 -- Cajus Pollmeier <cajus@debian.org>  Sun, 15 Jan 2012 23:54:37 +0100

=== debian/control ===
Source: qpid-cpp
Section: misc
Priority: extra
Maintainer: Cajus Pollmeier <cajus@debian.org>
Build-Depends: debhelper (>= 8.9.0~), autotools-dev, autoconf (>= 2.61), automake (>= 1.9.6), libtool (>= 1.5.22), libboost-all-dev (>= 1.35), ruby (>= 1.8.4), ruby-dev, uuid-dev, libopenais-dev (>= 0.80.3), libsasl2-dev, libxqilla-dev (>= 2.0.0), libxmltooling5, libibverbs-dev, librdmacm-dev, libnspr4-dev, libnss3-dev, libssl-dev, sasl2-bin, libcorosync-dev, libxerces-c-dev (>= 2.7.0), libcman-dev, swig (>= 1.3.35), python (>= 2.6.6-3~), doxygen, help2man, valgrind [any-i386 any-amd64 arm], zip, procps, libnss3-tools
X-Python-Version: 2.7
Standards-Version: 3.9.2
Homepage: http://qpid.apache.org
Vcs-Git: git://github.com/cajus/qpid-cpp-debian.git
Vcs-Browser: https://github.com/cajus/qpid-cpp-debian

Package: qpidd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, libsasl2-modules, sasl2-bin
Replaces: qpid-broker
Conflicts: qpid-broker
Description: enterprise messaging system - AMQP broker
 Apache Qpid is a cross-platform enterprise messaging system which implements
 the Advanced Message Queuing Protocol (AMQP), providing message brokers
 written in C++ and Java, along with clients for C++, Java JMS, .Net, Python,
 and Ruby.
 .
 This package provides the AMQP broker.

Package: qpid-client
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: enterprise messaging system - AMQP client
 Apache Qpid is a cross-platform enterprise messaging system which implements
 the Advanced Message Queuing Protocol (AMQP), providing message brokers
 written in C++ and Java, along with clients for C++, Java JMS, .Net, Python,
 and Ruby.
 .
 This package provides the AMQP client support.

Package: libqmf1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: multiarch-support
Multi-Arch: same
Description: enterprise messaging system - QMF libraries
 Apache Qpid is a cross-platform enterprise messaging system which implements
 the Advanced Message Queuing Protocol (AMQP), providing message brokers
 written in C++ and Java, along with clients for C++, Java JMS, .Net, Python,
 and Ruby.
 .
 This package provides the Qpid Management Framework libraries.

Package: libqmf-dev
Architecture: any
Section: libdevel
Depends: libqmf1 (= ${binary:Version}), ${misc:Depends}
Suggests: qmfgen
Multi-Arch: same
Description: enterprise messaging system - QMF development files
 Apache Qpid is a cross-platform enterprise messaging system which implements
 the Advanced Message Queuing Protocol (AMQP), providing message brokers
 written in C++ and Java, along with clients for C++, Java JMS, .Net, Python,
 and Ruby.
 .
 This package provides the Qpid Management Framework development files.

Package: libqmf2-1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: multiarch-support
Multi-Arch: same
Description: enterprise messaging system - QMF2 libraries
 Apache Qpid is a cross-platform enterprise messaging system which implements
 the Advanced Message Queuing Protocol (AMQP), providing message brokers
 written in C++ and Java, along with clients for C++, Java JMS, .Net, Python,
 and Ruby.
 .
 This package provides the QMF2 libraries.

Package: libqmf2-dev
Architecture: any
Section: libdevel
Depends: libqmf2-1 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Suggests: qmfgen
Description: enterprise messaging system - QMF2 development files
 Apache Qpid is a cross-platform enterprise messaging system which implements
 the Advanced Message Queuing Protocol (AMQP), providing message brokers
 written in C++ and Java, along with clients for C++, Java JMS, .Net, Python,
 and Ruby.
 .
 This package provides the QMF2 development files.

Package: libqmfconsole2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: multiarch-support
Multi-Arch: same
Description: enterprise messaging system - QMF console library
 Apache Qpid is a cross-platform enterprise messaging system which implements
 the Advanced Message Queuing Protocol (AMQP), providing message brokers
 written in C++ and Java, along with clients for C++, Java JMS, .Net, Python,
 and Ruby.
 .
 This package provides the QMF console library.

Package: libqmfconsole2-dev
Architecture: any
Section: libdevel
Depends: libqmfconsole2 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: enterprise messaging system - QMF console development files
 Apache Qpid is a cross-platform enterprise messaging system which implements
 the Advanced Message Queuing Protocol (AMQP), providing message brokers
 written in C++ and Java, along with clients for C++, Java JMS, .Net, Python,
 and Ruby.
 .
 This package provides the QMF console development files.

Package: libqpidmessaging2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: multiarch-support
Multi-Arch: same
Description: enterprise messaging system - AMQP messaging libraries
 Apache Qpid is a cross-platform enterprise messaging system which implements
 the Advanced Message Queuing Protocol (AMQP), providing message brokers
 written in C++ and Java, along with clients for C++, Java JMS, .Net, Python,
 and Ruby.
 .
 This package provides the AMQP messaging libraries.

Package: libqpidmessaging2-dev
Architecture: any
Section: libdevel
Depends: libqpidmessaging2 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: enterprise messaging system - AMQP messaging development files
 Apache Qpid is a cross-platform enterprise messaging system which implements
 the Advanced Message Queuing Protocol (AMQP), providing message brokers
 written in C++ and Java, along with clients for C++, Java JMS, .Net, Python,
 and Ruby.
 .
 This package provides the AMQP messaging development files.

Package: libsslcommon2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: multiarch-support
Multi-Arch: same
Description: enterprise messaging system - common SSL libraries
 Apache Qpid is a cross-platform enterprise messaging system which implements
 the Advanced Message Queuing Protocol (AMQP), providing message brokers
 written in C++ and Java, along with clients for C++, Java JMS, .Net, Python,
 and Ruby.
 .
 This package provides the AMQP SSL libraries.

Package: libsslcommon2-dev
Architecture: any
Section: libdevel
Depends: libsslcommon2 (= ${binary:Version}), ${misc:Depends}, uuid-dev
Multi-Arch: same
Description: enterprise messaging system - common SSL development files
 Apache Qpid is a cross-platform enterprise messaging system which implements
 the Advanced Message Queuing Protocol (AMQP), providing message brokers
 written in C++ and Java, along with clients for C++, Java JMS, .Net, Python,
 and Ruby.
 .
 This package provides the AMQP SSL development files.

Package: librdmawrap2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: multiarch-support
Multi-Arch: same
Description: enterprise messaging system - RDMA libraries
 Apache Qpid is a cross-platform enterprise messaging system which implements
 the Advanced Message Queuing Protocol (AMQP), providing message brokers
 written in C++ and Java, along with clients for C++, Java JMS, .Net, Python,
 and Ruby.
 .
 This package provides the AMQP Remote Direct Memory Access libraries.

Package: librdmawrap2-dev
Architecture: any
Section: libdevel
Depends: librdmawrap2 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: enterprise messaging system - RDMA development files
 Apache Qpid is a cross-platform enterprise messaging system which implements
 the Advanced Message Queuing Protocol (AMQP), providing message brokers
 written in C++ and Java, along with clients for C++, Java JMS, .Net, Python,
 and Ruby.
 .
 This package provides the AMQP Remote Direct Memory Access development files.

Package: libqpidtypes1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: multiarch-support
Multi-Arch: same
Description: enterprise messaging system - API libraries
 Apache Qpid is a cross-platform enterprise messaging system which implements
 the Advanced Message Queuing Protocol (AMQP), providing message brokers
 written in C++ and Java, along with clients for C++, Java JMS, .Net, Python,
 and Ruby.
 .
 This package provides the AMQP libraries.

Package: libqpidtypes1-dev
Architecture: any
Section: libdevel
Depends: libqpidtypes1 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: enterprise messaging system - API development files
 Apache Qpid is a cross-platform enterprise messaging system which implements
 the Advanced Message Queuing Protocol (AMQP), providing message brokers
 written in C++ and Java, along with clients for C++, Java JMS, .Net, Python,
 and Ruby.
 .
 This package provides the AMQP development files.

Package: libqpidcommon2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: multiarch-support
Multi-Arch: same
Description: enterprise messaging system - common libraries
 Apache Qpid is a cross-platform enterprise messaging system which implements
 the Advanced Message Queuing Protocol (AMQP), providing message brokers
 written in C++ and Java, along with clients for C++, Java JMS, .Net, Python,
 and Ruby.
 .
 This package provides the common AMQP libraries.

Package: libqpidcommon2-dev
Architecture: any
Section: libdevel
Depends: libqpidcommon2 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: enterprise messaging system - common development files
 Apache Qpid is a cross-platform enterprise messaging system which implements
 the Advanced Message Queuing Protocol (AMQP), providing message brokers
 written in C++ and Java, along with clients for C++, Java JMS, .Net, Python,
 and Ruby.
 .
 This package provides the common AMQP development files.

Package: libqpidclient2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: multiarch-support
Multi-Arch: same
Description: enterprise messaging system - client libraries
 Apache Qpid is a cross-platform enterprise messaging system which implements
 the Advanced Message Queuing Protocol (AMQP), providing message brokers
 written in C++ and Java, along with clients for C++, Java JMS, .Net, Python,
 and Ruby.
 .
 This package provides the AMQP client libraries.

Package: libqpidclient2-dev
Architecture: any
Section: libdevel
Depends: libqpidclient2 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: enterprise messaging system - client development files
 Apache Qpid is a cross-platform enterprise messaging system which implements
 the Advanced Message Queuing Protocol (AMQP), providing message brokers
 written in C++ and Java, along with clients for C++, Java JMS, .Net, Python,
 and Ruby.
 .
 This package provides the AMQP client development files.

Package: libqpidbroker2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: multiarch-support
Multi-Arch: same
Description: enterprise messaging system - broker libraries
 Apache Qpid is a cross-platform enterprise messaging system which implements
 the Advanced Message Queuing Protocol (AMQP), providing message brokers
 written in C++ and Java, along with clients for C++, Java JMS, .Net, Python,
 and Ruby.
 .
 This package provides the AMQP broker libraries.

Package: libqpidbroker2-dev
Architecture: any
Section: libdevel
Depends: libqpidbroker2 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: enterprise messaging system - broker development files
 Apache Qpid is a cross-platform enterprise messaging system which implements
 the Advanced Message Queuing Protocol (AMQP), providing message brokers
 written in C++ and Java, along with clients for C++, Java JMS, .Net, Python,
 and Ruby.
 .
 This package provides the AMQP broker development files.

Package: libqmfengine1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: multiarch-support
Multi-Arch: same

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# debian/rules for qpidd that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Set install ruby locations for configure
export RUBY_LIB = $(shell ruby1.8 -r rbconfig -e 'print Config::CONFIG["rubylibdir"]')
export RUBY_LIB_ARCH = $(shell ruby1.8 -r rbconfig -e 'print Config::CONFIG["archdir"]')

override_dh_auto_configure:
	dh_auto_configure -- --with-sasl --with-xml --with-rdma --with-ssl --with-cpg --with-swig --libexecdir='/usr/lib'

override_dh_auto_test:
	# do not test

%:
	dh  $@ --with python2
